public class UE11Aufgabe10 {
	public static void main(String[] args) {
		RubikSpiel rubikSpiel = new RubikSpiel();
		rubikSpiel.spielen();
	}
}

class RubikSpiel {

	private RubikRing[] ringe;

	public RubikSpiel() {
		IO.println("Infos!");
		IO.println("Schnittindex 1 = " + RubikRing.SCHNITTINDEX1);
		IO.println("Schnittindex 2 = " + RubikRing.SCHNITTINDEX2);
		IO.println("Farbe Schwarz = " + RubikKugel.SCHWARZ);
		IO.println("Farbe Gelb = " + RubikKugel.GELB);
		IO.println("Farbe Rot = " + RubikKugel.ROT);
		IO.println("Farbe Blau = " + RubikKugel.BLAU);

		char farbe = this.readFarbe("Farbe am Schnittindex oben: ");
		RubikKugel schnittKugelOben = new RubikKugel(farbe);

		farbe = this.readFarbe("Farbe am Schnittindex unten: ");
		RubikKugel schnittKugelUnten = new RubikKugel(farbe);

		IO.println("Anfangszustand von Ring 1 (links)");
		RubikKugel[] kugeln1 = new RubikKugel[20];
		for (int i = 0; i < kugeln1.length; i++) {
			if (i == RubikRing.SCHNITTINDEX1) {
				kugeln1[i] = schnittKugelOben;
			} else if (i == RubikRing.SCHNITTINDEX2) {
				kugeln1[i] = schnittKugelUnten;
			} else {
				farbe = this.readFarbe("Farbe an Index " + i + ": ");
				kugeln1[i] = new RubikKugel(farbe);
			}
		}

		IO.println("Anfangszustand von Ring 2 (rechts)");
		RubikKugel[] kugeln2 = new RubikKugel[20];
		for (int i = 0; i < kugeln2.length; i++) {
			if (i == RubikRing.SCHNITTINDEX1) {
				kugeln2[i] = schnittKugelUnten;
			} else if (i == RubikRing.SCHNITTINDEX2) {
				kugeln2[i] = schnittKugelOben;
			} else {
				farbe = this.readFarbe("Farbe an Index " + i + ": ");
				kugeln2[i] = new RubikKugel(farbe);
			}
		}

		RubikRing[] ringe = { new RubikRing(0, kugeln1), new RubikRing(1, kugeln2) };
		this.ringe = ringe;
	}

	public void spielen() {
		this.ringe[0].print();
		this.ringe[1].print();
		while (true) {
			RubikSpielzug zug = this.zugEinlesen();
			if (zug.isLinksDrehung()) {
				this.ringe[zug.getRingNummer()].linksDrehen();
			} else {
				this.ringe[zug.getRingNummer()].rechtsDrehen();
			}
			this.ringe[0].print();
			this.ringe[1].print();
		}
	}

	private char readFarbe(String aufforderung) {
		char farbe = IO.readChar(aufforderung);
		while (!(farbe == 's' || farbe == 'g' || farbe == 'r' || farbe == 'b')) {
			farbe = IO.readChar("Fehler! " + aufforderung);
		}
		return farbe;

	}

	private RubikSpielzug zugEinlesen() {
		int ringNummer = IO.readInt("Ringnummer (links = 0; rechts = 1): ");
		while (!(ringNummer == 0 || ringNummer == 1)) {
			ringNummer = IO
					.readInt("Fehler, Ringnummer (links = 0; rechts = 1): ");
		}
		char drehung = IO.readChar("Drehung (links = l, rechts = r): ");
		while (!(drehung == 'l' || drehung == 'r')) {
			drehung = IO.readChar("Fehler, Drehung (links = l, rechts = r): ");
		}
		return new RubikSpielzug(ringNummer, drehung == 'l');
	}

}

class RubikRing {

	public final static int SCHNITTINDEX1 = 0;
	public final static int SCHNITTINDEX2 = 15;

	private int nummer;
	private RubikKugel[] kugeln;

	public RubikRing(int nummer, RubikKugel[] k) {
		this.nummer = nummer;
		this.kugeln = k;
	}

	public void linksDrehen() {
		char farbe = this.kugeln[0].getFarbe();
		for (int i = 1; i < this.kugeln.length; i++) {
			char farbeNeu = this.kugeln[i].getFarbe();
			this.kugeln[i].setFarbe(farbe);
			farbe = farbeNeu;
		}
		this.kugeln[0].setFarbe(farbe);
	}

	public void rechtsDrehen() {
		char farbe = this.kugeln[this.kugeln.length - 1].getFarbe();
		for (int i = this.kugeln.length - 2; i >= 0; i--) {
			char farbeNeu = this.kugeln[i].getFarbe();
			this.kugeln[i].setFarbe(farbe);
			farbe = farbeNeu;
		}
		this.kugeln[this.kugeln.length - 1].setFarbe(farbe);
	}

	public void print() {
		System.out.println("Ring " + this.nummer);
		for (int i = 0; i < this.kugeln.length; i++) {
			System.out.print(this.kugeln[i].getFarbe());
		}
		System.out.println();
	}
}

class RubikKugel {
	public static final char SCHWARZ = 's';
	public static final char GELB = 'g';
	public static final char ROT = 'r';
	public static final char BLAU = 'b';

	private char farbe;

	public RubikKugel(char farbe) {
		this.farbe = farbe;
	}

	public char getFarbe() {
		return this.farbe;
	}

	public void setFarbe(char farbe) {
		this.farbe = farbe;
	}
}

class RubikSpielzug {

	int ringNummer;
	boolean linksDrehung;

	public RubikSpielzug(int ring, boolean links) {
		this.ringNummer = ring;
		this.linksDrehung = links;
	}

	public int getRingNummer() {
		return this.ringNummer;
	}

	public boolean isLinksDrehung() {
		return this.linksDrehung;
	}

	public boolean isRechtsDrehung() {
		return !this.linksDrehung;
	}
}
