public class UE11Aufgabe19 {

	public static void main(String[] args) {
		int feldgroesse = feldgroesseErmitteln();
		LampenSpielfeld feld = new LampenSpielfeld(feldgroesse);
		LampenSpieler spieler = new LampenSpieler();

		feld.print();
		while (!feld.sindAlleLampenAn()) {
			LampenSpielzug zug = spieler.liefereNaechstenSpielzug(feldgroesse);
			feld.spielzugAusfuehren(zug);
			feld.print();
		}

	}

	static int feldgroesseErmitteln() {
		int feldgroesse = IO.readInt("Feldgroesse (2 < n < 10): ");
		while (feldgroesse < 3 || feldgroesse > 9) {
			feldgroesse = IO
					.readInt("Fehlerhafte Eingabe! Feldgroesse (2 < n < 10): ");
		}
		return feldgroesse;
	}

}


class LampenSpielzug {
	int reihe;
	int spalte;

	LampenSpielzug(int r, int s) {
		this.reihe = r;
		this.spalte = s;
	}

	int getReihe() {
		return this.reihe;
	}

	int getSpalte() {
		return this.spalte;
	}
}

class LampenSpieler {

	LampenSpielzug liefereNaechstenSpielzug(int groesse) {
		int reihe = IO
				.readInt("Reihe der Lampe, die umgeschaltet werden soll (0 <= r < "
						+ groesse + "): ");
		while (reihe < 0 || reihe >= groesse) {
			IO.println("Fehlerhafte Eingabe!");
			reihe = IO
					.readInt("Reihe der Lampe, die umgeschaltet werden soll (0 <= r < "
							+ groesse + "): ");
		}
		int spalte = IO
				.readInt("Spalte der Lampe, die umgeschaltet werden soll (0 <= r < "
						+ groesse + "): ");
		while (spalte < 0 || spalte >= groesse) {
			IO.println("Fehlerhafte Eingabe!");
			spalte = IO
					.readInt("Spalte der Lampe, die umgeschaltet werden soll (0 <= r < "
							+ groesse + "): ");
		}
		return new LampenSpielzug(reihe, spalte);
	}
}

class LampenSpielfeld {
	boolean[][] feld;

	LampenSpielfeld(int groesse) {
		this.feld = new boolean[groesse][groesse];
		for (int r = 0; r < groesse; r++) {
			for (int s = 0; s < groesse; s++) {
				this.feld[r][s] = false;
			}
		}
	}

	void spielzugAusfuehren(LampenSpielzug zug) {
		// betroffene Lampe umschalten
		this.feld[zug.getReihe()][zug.getSpalte()] = !this.feld[zug.getReihe()][zug
				.getSpalte()];

		// Nachbarlampen umschalten
		if (zug.getReihe() - 1 >= 0) {
			this.feld[zug.getReihe() - 1][zug.getSpalte()] = !this.feld[zug
					.getReihe() - 1][zug.getSpalte()];
		}
		if (zug.getReihe() + 1 < this.feld.length) {
			this.feld[zug.getReihe() + 1][zug.getSpalte()] = !this.feld[zug
					.getReihe() + 1][zug.getSpalte()];
		}
		if (zug.getSpalte() - 1 >= 0) {
			this.feld[zug.getReihe()][zug.getSpalte() - 1] = !this.feld[zug
					.getReihe()][zug.getSpalte() - 1];
		}
		if (zug.getSpalte() + 1 < this.feld[0].length) {
			this.feld[zug.getReihe()][zug.getSpalte() + 1] = !this.feld[zug
					.getReihe()][zug.getSpalte() + 1];
		}
	}

	boolean sindAlleLampenAn() {
		for (int r = 0; r < this.feld.length; r++) {
			for (int s = 0; s < this.feld[r].length; s++) {
				if (!this.feld[r][s]) {
					return false; // eine Lampe aus
				}
			}
		}
		return true; // alle Lampen an
	}

	void print() {
		// Spaltennummerierung
		System.out.print(' ');
		for (int s = 0; s < this.feld[0].length; s++) {
			System.out.print("" + s);
		}
		System.out.println();

		// Feldinhalt ausgeben
		for (int r = 0; r < this.feld.length; r++) {
			System.out.print(r); // Nummerierung
			for (int s = 0; s < this.feld[r].length; s++) {
				if (this.feld[r][s]) {
					System.out.print('+'); // Lampe an
				} else {
					System.out.print('.'); // Lampe aus
				}
			}
			System.out.println();
		}
	}
}
