class UKWRadio {

	final static double MIN_FREQUENZ = 87.5;
	final static double MAX_FREQUENZ = 108.0;
	final static double UNDEF_FREQUENZ = 0.0;

	double frequenz;

	double[] stationstasten;

	UKWRadio(int anzahl) {
		this.frequenz = 87.5;
		this.stationstasten = new double[anzahl];
		for (int i = 0; i < this.stationstasten.length; i++) {
			this.stationstasten[i] = UNDEF_FREQUENZ;
		}
	}

	double getAktuelleFrequenz() {
		return this.frequenz;
	}

	void frequenzVerringern() {
		this.frequenz -= 0.5;
		if (this.frequenz < MIN_FREQUENZ) {
			this.frequenz = MIN_FREQUENZ;
		}
	}

	void frequenzErhoehen() {
		this.frequenz += 0.5;
		if (this.frequenz > MAX_FREQUENZ) {
			this.frequenz = MAX_FREQUENZ;
		}
	}

	void frequenzSpeichern(int taste) {
		if (taste < 0 || taste >= this.stationstasten.length) {
			return;
		}
		this.stationstasten[taste] = this.frequenz;

	}

	void frequenzEinstellen(int taste) {
		if (taste < 0 || taste >= this.stationstasten.length) {
			return;
		}
		if (this.stationstasten[taste] == UNDEF_FREQUENZ) {
			return;
		}
		this.frequenz = this.stationstasten[taste];
	}
}

public class UE11Aufgabe3 {

	public static void main(String[] args) {
		UKWRadio radio = new UKWRadio(6);
		radio.frequenzErhoehen();
		radio.frequenzSpeichern(1);
		radio.frequenzErhoehen();
		System.out.println("" + radio.getAktuelleFrequenz());
		radio.frequenzEinstellen(1);
		System.out.println("" + radio.getAktuelleFrequenz());
	}
}
